package jp.veltec.pdftable;

import java.util.HashMap;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.FileInputStream;
import java.io.InputStreamReader;
import java.io.BufferedReader;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import java.text.NumberFormat;


public class PdfTableTest2{


    public static void main(String[] args){

		NumberFormat nfy=NumberFormat.getCurrencyInstance();
		NumberFormat nf=NumberFormat.getInstance();
		PdfTableBuilder tableBuilder = new PdfTableBuilder();

		try{
			File template = new File("Sample2.xml");
			DocumentBuilder builder = DocumentBuilderFactory.newInstance().newDocumentBuilder();
			org.w3c.dom.Document xmlDocument = builder.parse(template);
			org.w3c.dom.Element xmlElement = xmlDocument.getDocumentElement();
			tableBuilder.setTemplate(xmlElement);

			HashMap<String,String> hmValues = new HashMap<String,String>();
			FileInputStream fis = new FileInputStream("data.txt");
			InputStreamReader isr = new InputStreamReader(fis,"utf-8");
			BufferedReader br = new BufferedReader(isr);
			int counter=1;
			int sum=0;
			hmValues.put("client-name",br.readLine()+"l");
			while(true){
				String line = br.readLine();
				if(line==null){
					break;
				}
				String[] column = line.split("\t");
				hmValues.put("item"+counter,column[0]);
				hmValues.put("price"+counter,nf.format(Integer.parseInt(column[1])));
				hmValues.put("qty"+counter,nf.format(Integer.parseInt(column[2])));
				int amount = Integer.parseInt(column[1])*Integer.parseInt(column[2]);
				hmValues.put("amount"+counter,nf.format(amount));
				sum+=amount;
				counter++;
			}
			hmValues.put("sum",nfy.format(sum));
			hmValues.put("tax",nfy.format(sum*0.05));
			hmValues.put("total",nfy.format(sum*1.05));
			br.close();
			isr.close();
			fis.close();
			tableBuilder.setData(hmValues);

		    String filename = "Sample2.pdf";
			tableBuilder.setOutputStream(new FileOutputStream(filename));

			tableBuilder.process();

		}catch(org.xml.sax.SAXException e){
			e.printStackTrace();
		}catch(javax.xml.parsers.ParserConfigurationException e){
			e.printStackTrace();
		}catch(IOException e){
			e.printStackTrace();
		}
	}

}
